﻿include("functions_basic");


/*********************************************************************************
**********************************************************************************
                     FONCTIONS D'AIDE A LA DECISION ET D'ESTIMATION
**********************************************************************************
*********************************************************************************/

//retourne la force de frappe potentielle de l'ennemi environant. Il ne s'agit que
// d'une approximation basée sur l'arme actuellement équipée, la distance, la force
// du/des poireau. Cette fonction stockera la liste des dégats subits (selon l'estimation)
// dans le tableau functions_futurs_damage et la somme de ces dégats dans
//functions_futurs_damage_sum
//aucune réduction de vos armures n'est calculée, ce sont donc les dégats bruts qui 
//sont retournés
function analyse_danger() {
	if (FUNCTION_DEBUG)
		debug("Différence de dégats dubis: " + (functions_last_turn_life- getLife() - functions_futurs_damage_sum));
	var sum = 0;
	var damages = [];
	var indexD = 0;
	for (var i in getAliveEnemies())
	{
		if (getWeapon(i) != null)
			for (var j=1; j<getTP(i); j+=getWeaponCost(getWeapon(i))) {
				//prerequis: lvl 37
				if (getWeaponMinScope(getWeapon(i)) <= getPathLength(getCell(), getCell(i))+getMP(i)) {
				//sinon:
				//if (getWeaponMinScope(getWeapon(i)) <= getDistance(getCell(), getCell(i))+getMP(i)) {
					var tedamage = getMeanDamage(getWeapon(i)) * (1 + getForce(i)/100) * 
							(1-getRelativeShield()/100) - getAbsoluteShield();
					if (tedamage <0)
						tedamage = 0;
					sum += tedamage;
					damages[indexD] = tedamage;
					indexD++;
				}
			}
	}
	functions_futurs_damage_sum = sum;
	functions_futurs_damage = damages;
	if (FUNCTION_DEBUG)
		debug("dégats potentiels subis au prochain tour: " + sum);
	return sum;
}

/* ********************************************************************
***********************************************************************
				GESTION DES PUCES
***********************************************************************
***********************************************************************/

//renvoie true si la puce est en cours de recharge
function isInRecovery(chip) {
	for (var i in functions_recover_chip) {
		if (i[0] == chip) {
			if (i[1] > 0)
				return true;
		}
	}
	return false;
}

//à utiliser au lieu de useChip. permet de pouvoir utiliser les fonctions 
//myCanUseChip, et d'autres
function myUseChip(chip, target) {
	var result = useChip(chip, target);
	if (result == USE_INVALID_COOLDOWN)
		debugW("Le cooldown de la puce " + getChipName(chip) + "n'était pas achevé");
	if (result == USE_NOT_ENOUGH_TP)
		debugW("Vous n'avez pas assez de points de tour pour utiliser la puce" + getChipName(chip) + " (" + getTP() + "/" + getChipCost(chip)+")");
	if (result == USE_SUCCESS) {
		addChipToMemory(chip);
		if (FUNCTION_DEBUG)
			debug("utilisation de la puce " + getChipName(chip) + " réussie");
	}
}

//test si on peut utiliser la puce chip sur target. Si la fonction renvoie true,
//c'est que TOUT a été testé, et la puce pourra vraiment etre utilisée
function myCanUseChip(chip, target) {
	if (getTP() >= getChipCost(chip))
		if (canUseChip(chip, target))
			if (!isInRecovery(chip))
				return true;
	return false;
}

