﻿include("functions_equip");
include("functions_Calcul");
include("functions_basic");
include("functions_config");
include("functions_target");
include("functions_AD");

/**************************************************************************
*************************** FONCTIONS DIVERSES ****************************
***************************************************************************

Ce fichier reprend diverses fonctions qui peuvent être utiles pour une IA
Elles ne sont aucunement utiles seules, mais permettent de simplifier certains
calculs dans des IA plus avancées.
Regles générales: 
=> Dans le cas ou une fonction prend des paramètres par adresse,
cela sera mentionné dans le nom de la fonctions grace à "_adr"
=> les fonctions ont leurs propres sorties de debug, warning et erreurs.
Les debug simples ne seront affichés que si vous mettez le booléen FUNCTIONS_DEBUG à true
*/

/*********************************************************************************
**********************************************************************************
              FONCTIONS D INITIALISATION DES DIFFERENTES FONCIONNALITES 
**********************************************************************************
*********************************************************************************/

//initialise toutes les variables nécessaires au bon fonctionnement des méthodes 
//de ce fichier
function Init_functions()
{
	if (!functions_init) {
		if (FUNCTION_DEBUG)
			debug("*** Début de l'initialisation de <functions> ***");
		functions_init = true;
		functions_last_turn_life = getLife();
		functions_last_turn_enemies_life = getEnemiesLife();
		functions_last_turn_allies_life = getAlliesLife();
		init_target();
		if(FUNCTION_ANALYSE_EQUIPMENT)
			FE_launchEvaluation();
		if (FUNCTION_DEBUG)
			debug("*** Fin de l'initialisation de <functions> ***");
	}
}

//appelable à chaque tour, cette fonction rafrachit différentes variables de calcul.
//appeler cette fonction en début de tour est nécessaire pour certains algorithmes.
function refresh_functions()
{
	if (FUNCTION_DEBUG)
		debug("*** Début du rafraichissement de <functions> ***");
	Init_functions();
	if (FUNCTION_MARK_START_CELL)
		mark(getCell(), FUNCTION_MARK_START_CELL_COLOR);
	if(FUNCTION_ANALYSE_EQUIPMENT)
		FE_ComputeEvaluation();
	analyse_danger();
	functions_last_turn_life = getLife();
	functions_last_turn_enemies_life = getEnemiesLife();
	functions_last_turn_allies_life = getAlliesLife();
	functions_said_powers = [];
	for (var i in functions_recover_chip) //on décrémente les recover des puces
		i[1] --;
	if (FUNCTION_DEBUG)
		debug("*** Fin du rafraichissement de <functions> ***");
}

function termineFunctions() {
	functions_force_soins += getAlliesLife() - functions_last_turn_allies_life;
	functions_force_frappe += functions_last_turn_enemies_life - getEnemiesLife();
	if (FUNCTION_DEBUG) {
		debug("*** Resultats du tour: ***");
		debug("force de frappe: " + (functions_last_turn_enemies_life - getEnemiesLife()));
		debug("force de soins: "+ (getAlliesLife()-functions_last_turn_allies_life));
		debug("force de frappe globale: "+ functions_force_frappe);
		debug("force de soin globale" + functions_force_soins);
	}
}
