﻿include("functions_config");
include("functions_equip");

//déclaration des différentes variables:
global functions_init = false;
global functions_futurs_damage = [];
global functions_futurs_damage_sum = 0;
global functions_last_turn_life;
global functions_last_turn_enemies_life;
global functions_last_turn_allies_life;

//statistiques:
global functions_force_frappe = 0;
global functions_force_soins = 0;

//mécanismes obscures :D
global functions_said_powers = [];
global functions_recover_chip = [];
global functions_simulation_isActive = false;

/*********************************************************************************
**********************************************************************************
                            FONCTIONS UTILITAIRES BASIQUES 
**********************************************************************************
*********************************************************************************/

//renvoie l'ennemi avec le moins de vie de l'équipe adverse. Le booléen permet de choisir
// si la fonction peut prendre les bulbes ou non
function getLowestLifeEnemy(bulbes)
{
	var enemies = getEnemies();
	var res;
	for (var i in enemies)
		if (getLife(i)>0 && ((!bulbes && !isSummon(i)) || (bulbes)))
			res = i;
	for (var i in enemies)
		if (getLife(i)>0 && getLife(i) < getLife(res) && ((!bulbes && !isSummon(i)) || (bulbes)))
			res = i;
	return res;
}

//ajoute un élément en fin de tableau (similaire à push(tab, el))
//ATTENTION!! coute cher en opérations. Préférez push en ce cas
function arrayAppend(tab, element) {
	if (tab == null) {
		debugE("Votre tableau est null!");
		return null;
	}
	if (typeOf(tab) == TYPE_ARRAY)
		tab[count(tab)] = element;
	else
		debugE("Attention, le tableau envoyé en paramètre n'en est pas un. Vérifiez que vous l'avez bien initialisé au moyen de = []");
	return tab;
}

//retourne l'effet demandé parmi une liste d'effet
//typiquement: getEffect(getChipEffect(CHIP_CURE), EFFECT_HEAL)[2]; 
//donnera le max de soins dela puce de soins
function getEffect(effects, wanted)
{
	var res = null;
	for (var i in effects) {
		if (i[0] == wanted)
			res = i;
	}
	return res;
}

//retourne la vie totale actuelle de la team ennemie
function getTotalLifeAlliesTeam()
{
	var res = 0;
	for (var i in getAllies())
		res = res + getLife(i);
	return res;
}

//retourne la vie totale actuelle de la team alliée
function getTotalLifeEnemyTeam()
{
	var res = 0;
	for (var i in getEnemies())
		res = res + getLife(i);
	return res;
}

//retourne la moyenne des dégats d'une puce ou d'une arme
function getMeanDamage(weapon)
{
	if (weapon == null)
		return -1;
	if (isChip(weapon)) {
		return (getEffect(getChipEffects(weapon), EFFECT_DAMAGE)[2] - 
			getEffect(getChipEffects(weapon), EFFECT_DAMAGE)[1]) / 2 +
			getEffect(getChipEffects(weapon), EFFECT_DAMAGE)[1];
	} else
		return (getEffect(getWeaponEffects(weapon), EFFECT_DAMAGE)[2] - 
		getEffect(getWeaponEffects(weapon), EFFECT_DAMAGE)[1]) /2 +
		getEffect(getWeaponEffects(weapon), EFFECT_DAMAGE)[1];
}

//retourne la moyenne arithmétique entre 2 nombre
function mean(a, b)
{
	return (a + b)/2;
}

//retourne true si la puce est une puce d'attaque
function isAggressiveChip(chip) {
	var res = false;
	for (var i in getChipEffects(chip))
	{
		if (i[0] == EFFECT_DAMAGE || i[0] == EFFECT_POISON)
			res = true;
	}
	return res;
}

//retourne toutes les puces d'attaque
function getAllAgressiveChip()
{
	var res = []; var index = 0;
	for (var i in getChips())
	{
		if (isAggressiveChip(i)) {
			res[index] = i; index ++;
		}
	}
	return res;
}

//retourne la puce/arme la moins cher
function getCheapestCW(liste)
{
	if (liste == null) {
		debugW("warning, la CW la moins cher d'une liste vide est null!");
		return null; 
	}
	var res = liste[0];
	for (var i in liste) {
		var actualCost;
		if (isChip(res))
			actualCost =getChipCost(res);
		else if (isWeapon(res))
			actualCost = getWeaponCost(res);
		if (isChip(i) && getChipCost(i) < actualCost)
			res = i;
		else if (isWeapon(i) && getWeaponCost(i) < actualCost)
			res = i;
	}
	return res;
}

//retourne le cout d'une arme ou d'une puce
function getCWCost(cw)
{
	if (cw == null) {
		debugW("warning, cout demandé d'une puce qui vaut null!");
		return 0; 
	}
	if (isChip(cw))	
		return getChipCost(cw);
	else
		return getWeaponCost(cw);
}

//retourne true si l'élément i est dans le tableau
function isInTab(i, tab)
{
	for (var j in tab)
		if (j == i)	
			return true;
	return false;
}

//retourne la case la plus proche d'une liste de cases
function getNearlyCell(cells) {
	if (count(cells) == 0)
		return null;
	var dist = getPathLength(getCell(), cells[0]);
	var res = 0;
	for (var i=0; i<count(cells); i++) {
		if (getPathLength(getCell(), cells[i])<=dist && getPathLength(getCell(), cells[i]) != null) {
			dist = getPathLength(getCell(), cells[i]);
			res = i;
		}
	}
	return cells[res];
}

//retourne toutes les puces qui ont l'effet concerné
function getChipsWithEffect(effect) {
	var res = [];
	var index = 0;
	for (var i in FE_CHIPS) {
		var hasEffect = false;
		if(i[1] <= getLevel()) {
			for (var j in getChipEffects(i[0]))
				if (j[0] == effect)
					hasEffect = true;
			if (hasEffect) {
				res[index] = i[0];
				index++;
			}
		}
	}
	return res;
}

//retourne le meilleur élément de tab grâce à l'évaluation par élément de fct
function evalueElements(tab, fct) {
	if (tab == null)
		return null;
	if (count(tab) == 0)
		return null;
	var res = tab[0];
	for (var i in  tab) {
		if (fct(i) >= res) {
			res = i;
		}
	}
	return res;
}

//ne pas utiliser, sert aux calculs internes
//rajoute la puce dans la liste des puces utilisées récements
function addChipToMemory(chip)
{
	var found = false;
	for (var i in functions_recover_chip) {
		if (i[0] == chip) {
			i[1] = getChipCooldown(chip);
			found = true;
		}
	}
	if (!found) {
		functions_recover_chip[count(functions_recover_chip)] = [chip, getChipCooldown(chip)];
	}
}


