﻿include("functions_Calcul");
include("functions_target");

/* Ce fichier est destiné à l'analyse de l'équipement du poireau 
Aucune fonctions ne devrait être utilisables dans une IA. */

//TODO: simuler un adversaire avec armure!

//Déclaration de l'ordre des armes/puces

//[arme, lvl_requis]
global FE_WEAPONS = [[WEAPON_PISTOL, 1],
					[WEAPON_MACHINE_GUN, 5],
					[WEAPON_DOUBLE_GUN, 9],
					[WEAPON_SHOTGUN, 17],
					[WEAPON_MAGNUM, 27],
					[WEAPON_LASER, 40],
					[WEAPON_GRENADE_LAUNCHER, 55],
					[WEAPON_FLAME_THROWER, 90],
					[WEAPON_DESTROYER, 109],
					[WEAPON_GAZOR, 135],
					[WEAPON_B_LASER, 170],
					[WEAPON_ELECTRISOR, 257],
					[WEAPON_M_LASER, 300]];
					
//[puce, lvl_requis]
global FE_CHIPS = [[CHIP_SHOCK, 1],
					[CHIP_PEBBLE, 4],
					[CHIP_SPARK, 7],
					[CHIP_ICE, 9],
					[CHIP_BANDAGE, 10],
					[CHIP_HELMET, 11],
					[CHIP_ROCK, 15],
					[CHIP_WALL, 17],
					[CHIP_STRETCHING, 17],
					[CHIP_PROTEIN, 18],
					[CHIP_SHIELD, 19],
					[CHIP_CURE, 21],
					[CHIP_MOTIVATION, 24],
					[CHIP_FLASH, 24],
					[CHIP_LEATHER_BOOTS, 27],
					[CHIP_FLAME, 29],
					[CHIP_STEROID, 37],
					[CHIP_RAMPART, 37],
					[CHIP_DRIP, 45],
					[CHIP_WARM_UP, 47],
					[CHIP_PUNY_BULB, 52],
					[CHIP_STALACTITE, 55],
					[CHIP_ARMOR, 55],
					[CHIP_WINGED_BOOTS, 65],
					[CHIP_VACCINE, 66],
					[CHIP_LIGHTNING, 71],
					[CHIP_FORTRESS, 72],
					[CHIP_ADRENALINE, 74],
					[CHIP_ROCKFALL, 77],
					[CHIP_LIBERATION, 80],
					[CHIP_ICEBERG, 81],
					[CHIP_REGENERATION, 85],
					[CHIP_ARMORING, 90],
					[CHIP_METEORITE, 102],
					[CHIP_REFLEXES, 127],
					[CHIP_ROCKY_BULB, 131],
					[CHIP_DOPING, 135],
					[CHIP_TELEPORTATION, 150],
					[CHIP_ICED_BULB, 151],
					[CHIP_REMISSION, 169],
					[CHIP_DEVIL_STRIKE, 171],
					[CHIP_HEALER_BULB, 174],
					[CHIP_SEVEN_LEAGUE_BOOTS, 175],
					[CHIP_RAGE, 196],
					[CHIP_METALLIC_BULB, 221],
					[CHIP_INVERSION, 222],
					[CHIP_FIRE_BULB, 250],
					[CHIP_CARAPACE, 259],
					[CHIP_LIGHTNING_BULB, 289],
					[CHIP_RESURRECTION, 301]];
	
global FE_WEAPON_FILTERED = []; //liste des armes en dessous de votre niveau
global FE_CHIPS_FILTERED = []; //liste des puces en dessous du niveau du poireau
global FE_RESULT_EQUIPED = []; //des buildBetterWeapons pour chaque PT possible (1,2,3,...)
global FE_RESULT_GLOBAL = []; //meme chose mais avec TOUTES les armes possible, et ce sur plusieurs tours
global FE_RESULT_GLOBAL_SORTED = []; //on trie ce dernier tableau par résultat sous la
//forme: [[cw, nbreOccurence], [cw, nbreOccurence]];

global FE_RESULT_CW_IMP = [];

global FE_stateEvaluation = false;
global FE_isAnalysing = 0; //numéro de la simulation a lancer

function FE_launchEvaluation() {
	debug("*************************************************************");
	debug("      ANALYSE DE L'EQUIPEMENT DU POIREAU " + getName());
	debug("*************************************************************");
	debug("FE_ANALYSE: initialisation de l'equipement");
	FE_removeUnusuableChips();
	debug("FE_ANALYSE: estimation des meilleurs plages de degats de votre niveau");
}

function FE_ComputeEvaluation() {
	if (FE_stateEvaluation)
		return true;
	var state = FE_ComputeBetterDamagesNonEquiped();
	if (state) {
		debug("FE_ANALYSE: Resultat des meilleurs constructions d'equipement pour votre niveau:");
		classBetterWeapons();
		debug("*************************************************************");
		debug("      FIN DE L'ANALYSE DE L'EQUIPEMENT DU POIREAU " + getName());
		debug("*************************************************************");
		FE_printTopCW();
		debug("*************************************************************");
		FE_stateEvaluation = true;
	} else {
		debug("*********** La suite de l'évaluation au prochain tour :p **********");
	}
	return state;
}
	
function FE_removeUnusuableChips() {
	for (var i in FE_WEAPONS) {
		if (i[1] <= getLevel() && !isInTab(FUNCTION_CW_TO_REMOVE, i[0]))
			push(FE_WEAPON_FILTERED, i[0]);
	}
	for (var i in FE_CHIPS) {
		if (i[1] <= getLevel() && isAggressiveChip(i[0]) && !isInTab(i[0],FUNCTION_CW_TO_REMOVE))
			push(FE_CHIPS_FILTERED, i[0]);
	}
}

//extraire le meilleur builderBetterWeapon d'une liste
function extractBetterBBWv2(tab, target) {
	var meanDamage = 0;
	var indexFound = -1;
	for (var i=0; i<count(tab); i++) {
		if (evaluePower(tab[i], target) / (FUNCTION_ANALYSE_MIN_TP_ATTACK+i) > meanDamage) {
			indexFound = i;
			meanDamage = (evaluePower(tab[i], target) / (FUNCTION_ANALYSE_MIN_TP_ATTACK+i));
		}
	}	
	return tab[indexFound];
}

function extractCooldownsAndDecrease(tab, cw) {
	for(var i in cw) {
		if (isChip(i)) {
			if (getChipCooldown(i) != 0)
				tab[count(tab)] = [i, getChipCooldown(i)];
		}
		if (!isInTab(i, FE_RESULT_CW_IMP))
			FE_RESULT_CW_IMP[count(FE_RESULT_CW_IMP)] = i;
	}
	var res = [];
	for (var i=0; i<count(tab); i++) {
		tab[i][1]--;
		if (tab[i][1] >0)
			res[count(res)] = tab[i];
	}
	return res;
}

//renvoie un tableau avec la liste des puces en cooldowns
function buildFilter(cd) {
	var res = [];
	for (var i in cd) {
		if (i[1]>=1)
			if (!isInTab(res, i[0]))
				res[count(res)] = i[0];
	}
	return res;
}

function applyFilter(filter, tab) {
	var res = [];
	for (var i in tab)
		if (!isInTab(i, filter))
			res[count(res)] = i;
	return res;
}

function FE_ComputeBetterDamagesNonEquiped() {
	FE_RESULT_GLOBAL = [];
	activateSimulation();
	debug(count(TA_man) + " simulations a tester détectées");
	if (count(TA_man) <= FE_isAnalysing)
		return true;
	var ta = TA_man[FE_isAnalysing];
	var temp = [];
	var bestTurnCost = -1;
	var filter = [];
	var cooldowns = [];
	var testWeap = arrayConcat(FE_WEAPON_FILTERED, FE_CHIPS_FILTERED);
	var baseWeap = testWeap;
	for (var iter=0; iter<4; iter++) {
		temp = []; //reinit
		//on construit les builderBetterWeapons_v2
		for (var i = FUNCTION_ANALYSE_MIN_TP_ATTACK-1; i<FUNCTION_ANALYSE_MAX_TP_ATTACK; i++) {
			temp[i-FUNCTION_ANALYSE_MIN_TP_ATTACK+1] = buildBetterWeapons_v2(testWeap,
								i+1, ta, false, getWeapon());
		}
		//on extrait le meilleur
		var best = extractBetterBBWv2(temp, ta);
		//on active le cooldown des puces concernées
		cooldowns = extractCooldownsAndDecrease(cooldowns, best);
		filter = buildFilter(cooldowns);
		testWeap = applyFilter(filter, baseWeap);
		FE_RESULT_GLOBAL[count(FE_RESULT_GLOBAL)] = temp;
	}
	deactivateSimulation();
	FE_isAnalysing++;
	if (count(TA_man) <= FE_isAnalysing)
		return true;
	return false;
}

//pour classBetterWeapons, on compte les occurences ([cw, occu])
function FE_addOneToTemp(array, cw) {
	var found = false;
	for (var i= 0; i<count(array); i++) {
		if (array[i][0] == cw) {
			found = true;
			array[i][1] = array[i][1] + 1;
		}
	}
	if (!found) {
		array[count(array)] = [cw, 1];
	}
	return array;
}

function classBetterWeapons() {
	var temp = [];
	for (var i in FE_RESULT_GLOBAL) {
		for (var j in i) {
			for (var k in j)
				temp = FE_addOneToTemp(temp, k);
		}
	}
	FE_RESULT_GLOBAL_SORTED = arraySort(temp, function (a,b) 
			{if (a[1] < b[1]) return 1;
			if (a[1] > b[1]) return -1; return 0;});
}

function FE_printTopCW() {
	debug("* FE_ANALYSE: Les armes/puces indispensables sont: ");
	var found = 0;
	for (var i in FE_RESULT_CW_IMP) {
		if (isWeapon(i))
			debug("* " + getWeaponName(i));
		else
			debug("* " + getChipName(i));
	}
	found = 0;
	debug("* " + "FE_ANALYSE: Les meilleurs puces/armes d'attaques sont:");
	for (var i in FE_RESULT_GLOBAL_SORTED) {
		if (isChip(i[0]))
			debug("* " + getChipName(i[0]) + " (" + i[1] + " occurences)");
		else
			debug("* " + getWeaponName(i[0]) + " (" + i[1] + " occurences)");
	}
}


























