﻿include("functions_basic");

// Ce code vise à simuler une cible, ses stats, sa puissance, etc...
//NE PRENDS PAS DE BULBES COMME MODELES!

//un "faux poireau" est stocké dans ce fichier de cette manière:
/*
0:nom
1:type de poireaux (voir constantes plus bas)
2:level
3:vie
4:force
5:agilité
6:PT
7:PM
8:Coeurs
9-11: armes
12-20: puces
21+: effets actifs sur le poireau (marqué par la puce qui l'a donné et non pas sur la forme du wiki)
*/
//contient une liste de faux poireaux, de chaque type du fichier de configuration
global TA_man = [];
//contient la liste des poireaux adverses simulés: c'est-à-dire que les stats seront
//adaptées en fonction de leur équipement. Si par exemple le poireau A a dans son inventaire
//3 armures et bcp d'agilité, son double stocké ici aur probablement deux armures
//actives. Cela permet d'extrapoler à l'avance un combat-type contre cet adversaire
global TA_ennemy = [];

//active la simulation. Tant que deactivateSimulation() n'a pas été appelée, la plupart
//des fonctions de calculs tels que getPower se baseront sur les simulations, pas
//sur vous ou vos adversaires!
function activateSimulation() {
	if (FUNCTION_DEBUG)
		debugW("Attention, la simulation a été activée!");
	functions_simulation_isActive = true;
}

//désactive la simulation, les calculs vont de nouveau se rebaser sur les vrais poireaux
function deactivateSimulation() {
	if (FUNCTION_DEBUG)
		debugW("la simulation a été désactivée!");
	functions_simulation_isActive = false;
}

function init_target() {
	for (var i in getEnemies()) {
		if (!isSummon())
			push(TA_ennemy, TA_cloneLeek(i));
	}
	generateTAMans();
}

//renvoie un tableau contenant la fameuse évalution du poireau en milieu de combat
//On lui place donc la moitié de ses armures. Pq la moitié? Car placer tout serait
//une prise de risques énorme, surtout avec la puce CHIP_DEBUFF, qui arrive au niveau
//80-90.
function TA_cloneLeek(leek) {
	var res = [];
	res[0] = getName(leek);
	res[1] = "NON_EVALUATED";
	res[2] = getLevel(leek);
	res[3] = getLife(leek);
	res[4] = getStrength(leek);
	res[5] = getAgility(leek);
	res[6] = getTP(leek);
	res[7] = getMP(leek);
	res[8] = getCores(leek);
	//REQUIS LVL 57
	var weaps = getWeapons(leek);
	for (var i=0; i<3; i++)
		if (count(weaps) < i+1)
			weaps[count(weaps)] = null;
	//DANS LE CAS CONTRAIRE (<57), ON PREND VOS ARMES:
	/*
	var weaps = getWeapons();
	for (var i=0; i<3; i++)
		if (count(weaps) < i+1)
			weaps[count(weaps)] = null;
	*/
	res[9] = weaps[0];
	res[10] = weaps[1];
	res[11] = weaps[2];
	/* pareil avec les puces */
	var chips = getChips(leek);
	for (var i=0; i<9; i++)
		if (count(chips) < i+1)
			chips[count(chips)] = null;
	//DANS LE CAS CONTRAIRE (<57), ON PREND VOS puces:
	/*
	var chips = getChips();
	for (var i=0; i<9; i++)
		if (count(chips) < i+1)
			chips[count(chips)] = null;
	*/
	res[12] = chips[0];
	res[13] = chips[1];
	res[14] = chips[2];
	res[15] = chips[3];
	res[16] = chips[4];
	res[17] = chips[5];
	res[18] = chips[6];
	res[19] = chips[7];
	res[20] = chips[8];
	//Si on rajoute des éléments, ne pas oublier de changer l'index de base dans TA_createEffects
	res = TA_createEffects(res);
	res[1] = TA_estimateTypeLeek(res);
	debug(getName(leek) + " a été considéré comme étant de type " + res[1][0] + " avec une marge d'erreur de " + res[1][1]);
	res[1] = res[1][0];
	return res;
}

//créé les effets que l'on pourrait trouver sur le leek donné, en milieu de partie
//Il s'agit bien sur d'une estimation!
function TA_createEffects(tab) {
	var index = 21;
	var armors = getChipsWithEffect([EFFECT_ABSOLUTE_SHIELD, EFFECT_RELATIVE_SHIELD]);
	var mid = count(armors) / 2 + 1; // la moitié supérieure
	for (var i=0; i<mid; i++)
		tab[index + i] = armors[i];
	index += mid;
	var boosts = getChipsWithEffect([EFFECT_BOOST_MAX_LIFE, EFFECT_BUFF_AGILITY,
									EFFECT_BUFF_FORCE, EFFECT_BUFF_TP]);
	mid = count(boosts) / 2 + 1; // la moitié supérieure
	for (var i=0; i<mid; i++)
		tab[index + i] = boosts[i];
	return tab;
}

//en fonction des types prédéfinis, estime le type de jeu du poireau adverse.
function TA_estimateTypeLeek(tab) {
	var spentV = tab[3] - 100 - (5*tab[2]);
	var spentF = tab[4];
	var spentA = tab[5];
	var spentTP = (tab[6] - 10) * 80;
	var spentMP = (tab[7] - 3) * 50;
	var sum = spentV +spentF +spentA +spentTP +spentMP;
	spentV = spentV / sum * 100;
	spentF = spentF / sum * 100;
	spentA = spentA / sum * 100;
	spentTP = spentTP / sum * 100;
	spentMP = spentMP / sum * 100;
	var diff = 600;
	var chosen = -1;
	for (var i=0; i<count(TYPE_ENNEMY); i++) {
		var tempDiff = TA_getDiff(TYPE_ENNEMY[i], spentV, spentF, spentA, spentTP, spentMP);
		if (tempDiff < diff) {
			chosen = i;
			diff = tempDiff;
		}
	}
	return [TYPE_ENNEMY[chosen][0], diff];//on retourne le nom du type d'ennemi et la diff
}

//calculer l'écart avec le type d'ennemi proposé
function TA_getDiff(type, spentV, spentF, spentA, spentTP, spentMP) {
	var diff = 0;
	diff += abs(spentV - type[1]);
	diff += abs(spentF - type[2]);
	diff += abs(spentA - type[3]);
	diff += abs(spentTP - type[4]);
	diff += abs(spentMP - type[5]);
	return diff;
}

function generateTAMans() {
	var leek = [];
	var maxDepense = getLevel() * 5 + 45; //45 du niveau 1 (avec 5 décomptés)
	for (var i=0; i<count(TYPE_ENNEMY); i++) {
		leek[0] = "fake_" + TYPE_ENNEMY[i][0];
		leek[1] = TYPE_ENNEMY[i][0];
		leek[2] = getLevel();
		leek[3] = 100 + (5*leek[2]) + (3 * TYPE_ENNEMY[i][1] * maxDepense) / 100;
		leek[4] = (TYPE_ENNEMY[i][2] * maxDepense) / 100;
		leek[5] = (TYPE_ENNEMY[i][3] * maxDepense) / 100;
		leek[6] = ((TYPE_ENNEMY[i][4] * maxDepense) / 100) / 80;
		leek[7] = ((TYPE_ENNEMY[i][5] * maxDepense) / 100) / 50;
		leek[8] = 1;
		// on prend nos armes par simplicité
		var weaps = getWeapons();
		for (var j=0; j<3; j++)
			if (count(weaps) < j+1)
				weaps[count(weaps)] = null;
		leek[9] = weaps[0];
		leek[10] = weaps[1];
		leek[11] = weaps[2];
		var chips = [];
		var boost_A = getChipsWithEffect([EFFECT_BUFF_AGILITY, EFFECT_HEAL]);
		var boost_F = getChipsWithEffect([EFFECT_BUFF_FORCE, EFFECT_DAMAGE]);
		var numA = TYPE_ENNEMY[i][2] / (TYPE_ENNEMY[i][3] + TYPE_ENNEMY[i][2]) * 9;
		var numF = TYPE_ENNEMY[i][3] / (TYPE_ENNEMY[i][3] + TYPE_ENNEMY[i][2]) * 9;
		for (var j=0; j<numA; j++) {
			leek[12 + j] = boost_A[randInt(0, count(boost_A))];
		}
		for (var j=0; j<numF; j++) {
			leek[12 + numA + j] = boost_F[randInt(0, count(boost_F))];
		}
		for (var j=0; j<9-numA-numF; j++)
			leek[j] = null;
		leek = TA_createEffects(leek);
		TA_man[i] = leek;
	}
}

//attention, leek est un tableau de simulation, pas un vrai leek!
function TA_GetRelativeShield(leek) {
	var res = 0;
	for (var i= 21; i<count(leek); i++) {
		if (leek[i] != null) {
			var effect = getEffect(getChipEffects(leek[i]), EFFECT_RELATIVE_SHIELD);
			if (effect != null) {
				res += (effect[2] - effect[1])/2 * (1+leek[5]/100);
			}
		}
	}
	return res;
}
//attention, leek est un tableau de simulation, pas un vrai leek!
function TA_GetAbsoluteShield(leek) {
	var res = 0;
	for (var i= 21; i<count(leek); i++) {
		if (leek[i] != null) {
			var effect = getEffect(getChipEffects(leek[i]), EFFECT_ABSOLUTE_SHIELD);
			if (effect != null) {
				res += (effect[2] - effect[1])/2 * (leek[5] / 50);
			}
		}
	}
	return res;
}
